
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Nginx学习笔记（六） 源码分析&amp;启动过程 / iVAN</title>

    <meta name="description" content="Nginx学习笔记（六） 源码分析&amp;启动过程 涉及到的基本函数 源码: 1 /* 2 * Copyright (C) Igor Sysoev 3 * Copyright (C) Nginx, Inc. 4 */ 5 6 7 #include &lt;ngx_config.h&gt; 8 #include &lt;ngx_core.h&gt; 9 #include &lt;nginx.h&gt; 10 11 12 static ngx_int_t ngx_add_inherited_sockets(ngx_cycle_t *cycle); 1 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Nginx学习笔记（六） 源码分析&amp;启动过程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>涉及到的基本函数</h2>
<p>源码：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>   1 /*
   2  * Copyright (C) Igor Sysoev
   3  * Copyright (C) Nginx, Inc.
   4  */
   5
   6
   7 #include &lt;ngx_config.h&gt;
   8 #include &lt;ngx_core.h&gt;
   9 #include &lt;nginx.h&gt;
  10
  11
  12 static ngx_int_t ngx_add_inherited_sockets(ngx_cycle_t *cycle);
  13 static ngx_int_t ngx_get_options(int argc, char *const *argv);
  14 static ngx_int_t ngx_process_options(ngx_cycle_t *cycle);
  15 static ngx_int_t ngx_save_argv(ngx_cycle_t *cycle, int argc, char *const *argv);
  16 static void *ngx_core_module_create_conf(ngx_cycle_t *cycle);
  17 static char *ngx_core_module_init_conf(ngx_cycle_t *cycle, void *conf);
  18 static char *ngx_set_user(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
  19 static char *ngx_set_env(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
  20 static char *ngx_set_priority(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
  21 static char *ngx_set_cpu_affinity(ngx_conf_t *cf, ngx_command_t *cmd,
  22     void *conf);
  23 static char *ngx_set_worker_processes(ngx_conf_t *cf, ngx_command_t *cmd,
  24     void *conf);
  25
  26
  27 static ngx_conf_enum_t  ngx_debug_points[] = {
  28     { ngx_string("stop"), NGX_DEBUG_POINTS_STOP },
  29     { ngx_string("abort"), NGX_DEBUG_POINTS_ABORT },
  30     { ngx_null_string, 0 }
  31 };
  32
  33
  34 static ngx_command_t  ngx_core_commands[] = {
  35
  36     { ngx_string("daemon"),
  37       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_FLAG,
  38       ngx_conf_set_flag_slot,
  39       0,
  40       offsetof(ngx_core_conf_t, daemon),
  41       NULL },
  42
  43     { ngx_string("master_process"),
  44       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_FLAG,
  45       ngx_conf_set_flag_slot,
  46       0,
  47       offsetof(ngx_core_conf_t, master),
  48       NULL },
  49
  50     { ngx_string("timer_resolution"),
  51       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
  52       ngx_conf_set_msec_slot,
  53       0,
  54       offsetof(ngx_core_conf_t, timer_resolution),
  55       NULL },
  56
  57     { ngx_string("pid"),
  58       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
  59       ngx_conf_set_str_slot,
  60       0,
  61       offsetof(ngx_core_conf_t, pid),
  62       NULL },
  63
  64     { ngx_string("lock_file"),
  65       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
  66       ngx_conf_set_str_slot,
  67       0,
  68       offsetof(ngx_core_conf_t, lock_file),
  69       NULL },
  70
  71     { ngx_string("worker_processes"),
  72       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
  73       ngx_set_worker_processes,
  74       0,
  75       0,
  76       NULL },
  77
  78     { ngx_string("debug_points"),
  79       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
  80       ngx_conf_set_enum_slot,
  81       0,
  82       offsetof(ngx_core_conf_t, debug_points),
  83       &amp;ngx_debug_points },
  84
  85     { ngx_string("user"),
  86       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE12,
  87       ngx_set_user,
  88       0,
  89       0,
  90       NULL },
  91
  92     { ngx_string("worker_priority"),
  93       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
  94       ngx_set_priority,
  95       0,
  96       0,
  97       NULL },
  98
  99     { ngx_string("worker_cpu_affinity"),
 100       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_1MORE,
 101       ngx_set_cpu_affinity,
 102       0,
 103       0,
 104       NULL },
 105
 106     { ngx_string("worker_rlimit_nofile"),
 107       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
 108       ngx_conf_set_num_slot,
 109       0,
 110       offsetof(ngx_core_conf_t, rlimit_nofile),
 111       NULL },
 112
 113     { ngx_string("worker_rlimit_core"),
 114       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
 115       ngx_conf_set_off_slot,
 116       0,
 117       offsetof(ngx_core_conf_t, rlimit_core),
 118       NULL },
 119
 120     { ngx_string("worker_rlimit_sigpending"),
 121       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
 122       ngx_conf_set_num_slot,
 123       0,
 124       offsetof(ngx_core_conf_t, rlimit_sigpending),
 125       NULL },
 126
 127     { ngx_string("working_directory"),
 128       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
 129       ngx_conf_set_str_slot,
 130       0,
 131       offsetof(ngx_core_conf_t, working_directory),
 132       NULL },
 133
 134     { ngx_string("env"),
 135       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
 136       ngx_set_env,
 137       0,
 138       0,
 139       NULL },
 140
 141 #if (NGX_THREADS)
 142
 143     { ngx_string("worker_threads"),
 144       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
 145       ngx_conf_set_num_slot,
 146       0,
 147       offsetof(ngx_core_conf_t, worker_threads),
 148       NULL },
 149
 150     { ngx_string("thread_stack_size"),
 151       NGX_MAIN_CONF|NGX_DIRECT_CONF|NGX_CONF_TAKE1,
 152       ngx_conf_set_size_slot,
 153       0,
 154       offsetof(ngx_core_conf_t, thread_stack_size),
 155       NULL },
 156
 157 #endif
 158
 159       ngx_null_command
 160 };
 161
 162
 163 static ngx_core_module_t  ngx_core_module_ctx = {
 164     ngx_string("core"),
 165     ngx_core_module_create_conf,
 166     ngx_core_module_init_conf
 167 };
 168
 169
 170 ngx_module_t  ngx_core_module = {
 171     NGX_MODULE_V1,
 172     &amp;ngx_core_module_ctx,                  /* module context */
 173     ngx_core_commands,                     /* module directives */
 174     NGX_CORE_MODULE,                       /* module type */
 175     NULL,                                  /* init master */
 176     NULL,                                  /* init module */
 177     NULL,                                  /* init process */
 178     NULL,                                  /* init thread */
 179     NULL,                                  /* exit thread */
 180     NULL,                                  /* exit process */
 181     NULL,                                  /* exit master */
 182     NGX_MODULE_V1_PADDING
 183 };
 184
 185
 186 ngx_uint_t          ngx_max_module;
 187
 188 static ngx_uint_t   ngx_show_help;
 189 static ngx_uint_t   ngx_show_version;
 190 static ngx_uint_t   ngx_show_configure;
 191 static u_char      *ngx_prefix;
 192 static u_char      *ngx_conf_file;
 193 static u_char      *ngx_conf_params;
 194 static char        *ngx_signal;
 195
 196
 197 static char **ngx_os_environ;
 198
 199
 200 int ngx_cdecl
 201 main(int argc, char *const *argv)
 202 {
 203     ngx_int_t         i;
 204     ngx_log_t        *log;
 205     ngx_cycle_t      *cycle, init_cycle;
 206     ngx_core_conf_t  *ccf;
 207
 208     ngx_debug_init();
 209
 210     if (ngx_strerror_init() != NGX_OK) {
 211         return 1;
 212     }
 213
 214     if (ngx_get_options(argc, argv) != NGX_OK) {
 215         return 1;
 216     }
 217
 218     if (ngx_show_version) {
 219         ngx_write_stderr("nginx version: " NGINX_VER NGX_LINEFEED);
 220
 221         if (ngx_show_help) {
 222             ngx_write_stderr(
 223                 "Usage: nginx [-?hvVtq] [-s signal] [-c filename] "
 224                              "[-p prefix] [-g directives]" NGX_LINEFEED
 225                              NGX_LINEFEED
 226                 "Options:" NGX_LINEFEED
 227                 "  -?,-h         : this help" NGX_LINEFEED
 228                 "  -v            : show version and exit" NGX_LINEFEED
 229                 "  -V            : show version and configure options then exit"
 230                                    NGX_LINEFEED
 231                 "  -t            : test configuration and exit" NGX_LINEFEED
 232                 "  -q            : suppress non-error messages "
 233                                    "during configuration testing" NGX_LINEFEED
 234                 "  -s signal     : send signal to a master process: "
 235                                    "stop, quit, reopen, reload" NGX_LINEFEED
 236 #ifdef NGX_PREFIX
 237                 "  -p prefix     : set prefix path (default: "
 238                                    NGX_PREFIX ")" NGX_LINEFEED
 239 #else
 240                 "  -p prefix     : set prefix path (default: NONE)" NGX_LINEFEED
 241 #endif
 242                 "  -c filename   : set configuration file (default: "
 243                                    NGX_CONF_PATH ")" NGX_LINEFEED
 244                 "  -g directives : set global directives out of configuration "
 245                                    "file" NGX_LINEFEED NGX_LINEFEED
 246                 );
 247         }
 248
 249         if (ngx_show_configure) {
 250             ngx_write_stderr(
 251 #ifdef NGX_COMPILER
 252                 "built by " NGX_COMPILER NGX_LINEFEED
 253 #endif
 254 #if (NGX_SSL)
 255 #ifdef SSL_CTRL_SET_TLSEXT_HOSTNAME
 256                 "TLS SNI support enabled" NGX_LINEFEED
 257 #else
 258                 "TLS SNI support disabled" NGX_LINEFEED
 259 #endif
 260 #endif
 261                 "configure arguments:" NGX_CONFIGURE NGX_LINEFEED);
 262         }
 263
 264         if (!ngx_test_config) {
 265             return 0;
 266         }
 267     }
 268
 269     /* TODO */ ngx_max_sockets = -1;
 270
 271     ngx_time_init();
 272
 273 #if (NGX_PCRE)
 274     ngx_regex_init();
 275 #endif
 276
 277     ngx_pid = ngx_getpid();
 278
 279     log = ngx_log_init(ngx_prefix);
 280     if (log == NULL) {
 281         return 1;
 282     }
 283
 284     /* STUB */
 285 #if (NGX_OPENSSL)
 286     ngx_ssl_init(log);
 287 #endif
 288
 289     /*
 290      * init_cycle-&gt;log is required for signal handlers and
 291      * ngx_process_options()
 292      */
 293
 294     ngx_memzero(&amp;init_cycle, sizeof(ngx_cycle_t));
 295     init_cycle.log = log;
 296     ngx_cycle = &amp;init_cycle;
 297
 298     init_cycle.pool = ngx_create_pool(1024, log);
 299     if (init_cycle.pool == NULL) {
 300         return 1;
 301     }
 302
 303     if (ngx_save_argv(&amp;init_cycle, argc, argv) != NGX_OK) {
 304         return 1;
 305     }
 306
 307     if (ngx_process_options(&amp;init_cycle) != NGX_OK) {
 308         return 1;
 309     }
 310
 311     if (ngx_os_init(log) != NGX_OK) {
 312         return 1;
 313     }
 314
 315     /*
 316      * ngx_crc32_table_init() requires ngx_cacheline_size set in ngx_os_init()
 317      */
 318
 319     if (ngx_crc32_table_init() != NGX_OK) {
 320         return 1;
 321     }
 322
 323     if (ngx_add_inherited_sockets(&amp;init_cycle) != NGX_OK) {
 324         return 1;
 325     }
 326
 327     ngx_max_module = 0;
 328     for (i = 0; ngx_modules[i]; i++) {
 329         ngx_modules[i]-&gt;index = ngx_max_module++;
 330     }
 331
 332     cycle = ngx_init_cycle(&amp;init_cycle);
 333     if (cycle == NULL) {
 334         if (ngx_test_config) {
 335             ngx_log_stderr(0, "configuration file %s test failed",
 336                            init_cycle.conf_file.data);
 337         }
 338
 339         return 1;
 340     }
 341
 342     if (ngx_test_config) {
 343         if (!ngx_quiet_mode) {
 344             ngx_log_stderr(0, "configuration file %s test is successful",
 345                            cycle-&gt;conf_file.data);
 346         }
 347
 348         return 0;
 349     }
 350
 351     if (ngx_signal) {
 352         return ngx_signal_process(cycle, ngx_signal);
 353     }
 354
 355     ngx_os_status(cycle-&gt;log);
 356
 357     ngx_cycle = cycle;
 358
 359     ccf = (ngx_core_conf_t *) ngx_get_conf(cycle-&gt;conf_ctx, ngx_core_module);
 360
 361     if (ccf-&gt;master &amp;&amp; ngx_process == NGX_PROCESS_SINGLE) {
 362         ngx_process = NGX_PROCESS_MASTER;
 363     }
 364
 365 #if !(NGX_WIN32)
 366
 367     if (ngx_init_signals(cycle-&gt;log) != NGX_OK) {
 368         return 1;
 369     }
 370
 371     if (!ngx_inherited &amp;&amp; ccf-&gt;daemon) {
 372         if (ngx_daemon(cycle-&gt;log) != NGX_OK) {
 373             return 1;
 374         }
 375
 376         ngx_daemonized = 1;
 377     }
 378
 379     if (ngx_inherited) {
 380         ngx_daemonized = 1;
 381     }
 382
 383 #endif
 384
 385     if (ngx_create_pidfile(&amp;ccf-&gt;pid, cycle-&gt;log) != NGX_OK) {
 386         return 1;
 387     }
 388
 389     if (cycle-&gt;log-&gt;file-&gt;fd != ngx_stderr) {
 390
 391         if (ngx_set_stderr(cycle-&gt;log-&gt;file-&gt;fd) == NGX_FILE_ERROR) {
 392             ngx_log_error(NGX_LOG_EMERG, cycle-&gt;log, ngx_errno,
 393                           ngx_set_stderr_n " failed");
 394             return 1;
 395         }
 396     }
 397
 398     if (log-&gt;file-&gt;fd != ngx_stderr) {
 399         if (ngx_close_file(log-&gt;file-&gt;fd) == NGX_FILE_ERROR) {
 400             ngx_log_error(NGX_LOG_ALERT, cycle-&gt;log, ngx_errno,
 401                           ngx_close_file_n " built-in log failed");
 402         }
 403     }
 404
 405     ngx_use_stderr = 0;
 406
 407     if (ngx_process == NGX_PROCESS_SINGLE) {
 408         ngx_single_process_cycle(cycle);
 409
 410     } else {
 411         ngx_master_process_cycle(cycle);
 412     }
 413
 414     return 0;
 415 }
 416
 417
 418 static ngx_int_t
 419 ngx_add_inherited_sockets(ngx_cycle_t *cycle)
 420 {
 421     u_char           *p, *v, *inherited;
 422     ngx_int_t         s;
 423     ngx_listening_t  *ls;
 424
 425     inherited = (u_char *) getenv(NGINX_VAR);
 426
 427     if (inherited == NULL) {
 428         return NGX_OK;
 429     }
 430
 431     ngx_log_error(NGX_LOG_NOTICE, cycle-&gt;log, 0,
 432                   "using inherited sockets from \"%s\"", inherited);
 433
 434     if (ngx_array_init(&amp;cycle-&gt;listening, cycle-&gt;pool, 10,
 435                        sizeof(ngx_listening_t))
 436         != NGX_OK)
 437     {
 438         return NGX_ERROR;
 439     }
 440
 441     for (p = inherited, v = p; *p; p++) {
 442         if (*p == ':' || *p == ';') {
 443             s = ngx_atoi(v, p - v);
 444             if (s == NGX_ERROR) {
 445                 ngx_log_error(NGX_LOG_EMERG, cycle-&gt;log, 0,
 446                               "invalid socket number \"%s\" in " NGINX_VAR
 447                               " environment variable, ignoring the rest"
 448                               " of the variable", v);
 449                 break;
 450             }
 451
 452             v = p + 1;
 453
 454             ls = ngx_array_push(&amp;cycle-&gt;listening);
 455             if (ls == NULL) {
 456                 return NGX_ERROR;
 457             }
 458
 459             ngx_memzero(ls, sizeof(ngx_listening_t));
 460
 461             ls-&gt;fd = (ngx_socket_t) s;
 462         }
 463     }
 464
 465     ngx_inherited = 1;
 466
 467     return ngx_set_inherited_sockets(cycle);
 468 }
 469
 470
 471 char **
 472 ngx_set_environment(ngx_cycle_t *cycle, ngx_uint_t *last)
 473 {
 474     char             **p, **env;
 475     ngx_str_t         *var;
 476     ngx_uint_t         i, n;
 477     ngx_core_conf_t   *ccf;
 478
 479     ccf = (ngx_core_conf_t *) ngx_get_conf(cycle-&gt;conf_ctx, ngx_core_module);
 480
 481     if (last == NULL &amp;&amp; ccf-&gt;environment) {
 482         return ccf-&gt;environment;
 483     }
 484
 485     var = ccf-&gt;env.elts;
 486
 487     for (i = 0; i &lt; ccf-&gt;env.nelts; i++) {
 488         if (ngx_strcmp(var[i].data, "TZ") == 0
 489             || ngx_strncmp(var[i].data, "TZ=", 3) == 0)
 490         {
 491             goto tz_found;
 492         }
 493     }
 494
 495     var = ngx_array_push(&amp;ccf-&gt;env);
 496     if (var == NULL) {
 497         return NULL;
 498     }
 499
 500     var-&gt;len = 2;
 501     var-&gt;data = (u_char *) "TZ";
 502
 503     var = ccf-&gt;env.elts;
 504
 505 tz_found:
 506
 507     n = 0;
 508
 509     for (i = 0; i &lt; ccf-&gt;env.nelts; i++) {
 510
 511         if (var[i].data[var[i].len] == '=') {
 512             n++;
 513             continue;
 514         }
 515
 516         for (p = ngx_os_environ; *p; p++) {
 517
 518             if (ngx_strncmp(*p, var[i].data, var[i].len) == 0
 519                 &amp;&amp; (*p)[var[i].len] == '=')
 520             {
 521                 n++;
 522                 break;
 523             }
 524         }
 525     }
 526
 527     if (last) {
 528         env = ngx_alloc((*last + n + 1) * sizeof(char *), cycle-&gt;log);
 529         *last = n;
 530
 531     } else {
 532         env = ngx_palloc(cycle-&gt;pool, (n + 1) * sizeof(char *));
 533     }
 534
 535     if (env == NULL) {
 536         return NULL;
 537     }
 538
 539     n = 0;
 540
 541     for (i = 0; i &lt; ccf-&gt;env.nelts; i++) {
 542
 543         if (var[i].data[var[i].len] == '=') {
 544             env[n++] = (char *) var[i].data;
 545             continue;
 546         }
 547
 548         for (p = ngx_os_environ; *p; p++) {
 549
 550             if (ngx_strncmp(*p, var[i].data, var[i].len) == 0
 551                 &amp;&amp; (*p)[var[i].len] == '=')
 552             {
 553                 env[n++] = *p;
 554                 break;
 555             }
 556         }
 557     }
 558
 559     env[n] = NULL;
 560
 561     if (last == NULL) {
 562         ccf-&gt;environment = env;
 563         environ = env;
 564     }
 565
 566     return env;
 567 }
 568
 569
 570 ngx_pid_t
 571 ngx_exec_new_binary(ngx_cycle_t *cycle, char *const *argv)
 572 {
 573     char             **env, *var;
 574     u_char            *p;
 575     ngx_uint_t         i, n;
 576     ngx_pid_t          pid;
 577     ngx_exec_ctx_t     ctx;
 578     ngx_core_conf_t   *ccf;
 579     ngx_listening_t   *ls;
 580
 581     ngx_memzero(&amp;ctx, sizeof(ngx_exec_ctx_t));
 582
 583     ctx.path = argv[0];
 584     ctx.name = "new binary process";
 585     ctx.argv = argv;
 586
 587     n = 2;
 588     env = ngx_set_environment(cycle, &amp;n);
 589     if (env == NULL) {
 590         return NGX_INVALID_PID;
 591     }
 592
 593     var = ngx_alloc(sizeof(NGINX_VAR)
 594                     + cycle-&gt;listening.nelts * (NGX_INT32_LEN + 1) + 2,
 595                     cycle-&gt;log);
 596     if (var == NULL) {
 597         ngx_free(env);
 598         return NGX_INVALID_PID;
 599     }
 600
 601     p = ngx_cpymem(var, NGINX_VAR "=", sizeof(NGINX_VAR));
 602
 603     ls = cycle-&gt;listening.elts;
 604     for (i = 0; i &lt; cycle-&gt;listening.nelts; i++) {
 605         p = ngx_sprintf(p, "%ud;", ls[i].fd);
 606     }
 607
 608     *p = '\0';
 609
 610     env[n++] = var;
 611
 612 #if (NGX_SETPROCTITLE_USES_ENV)
 613
 614     /* allocate the spare 300 bytes for the new binary process title */
 615
 616     env[n++] = "SPARE=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
 617                "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
 618                "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
 619                "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
 620                "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
 621
 622 #endif
 623
 624     env[n] = NULL;
 625
 626 #if (NGX_DEBUG)
 627     {
 628     char  **e;
 629     for (e = env; *e; e++) {
 630         ngx_log_debug1(NGX_LOG_DEBUG_CORE, cycle-&gt;log, 0, "env: %s", *e);
 631     }
 632     }
 633 #endif
 634
 635     ctx.envp = (char *const *) env;
 636
 637     ccf = (ngx_core_conf_t *) ngx_get_conf(cycle-&gt;conf_ctx, ngx_core_module);
 638
 639     if (ngx_rename_file(ccf-&gt;pid.data, ccf-&gt;oldpid.data) == NGX_FILE_ERROR) {
 640         ngx_log_error(NGX_LOG_ALERT, cycle-&gt;log, ngx_errno,
 641                       ngx_rename_file_n " %s to %s failed "
 642                       "before executing new binary process \"%s\"",
 643                       ccf-&gt;pid.data, ccf-&gt;oldpid.data, argv[0]);
 644
 645         ngx_free(env);
 646         ngx_free(var);
 647
 648         return NGX_INVALID_PID;
 649     }
 650
 651     pid = ngx_execute(cycle, &amp;ctx);
 652
 653     if (pid == NGX_INVALID_PID) {
 654         if (ngx_rename_file(ccf-&gt;oldpid.data, ccf-&gt;pid.data)
 655             == NGX_FILE_ERROR)
 656         {
 657             ngx_log_error(NGX_LOG_ALERT, cycle-&gt;log, ngx_errno,
 658                           ngx_rename_file_n " %s back to %s failed after "
 659                           "an attempt to execute new binary process \"%s\"",
 660                           ccf-&gt;oldpid.data, ccf-&gt;pid.data, argv[0]);
 661         }
 662     }
 663
 664     ngx_free(env);
 665     ngx_free(var);
 666
 667     return pid;
 668 }
 669
 670
 671 static ngx_int_t
 672 ngx_get_options(int argc, char *const *argv)
 673 {
 674     u_char     *p;
 675     ngx_int_t   i;
 676
 677     for (i = 1; i &lt; argc; i++) {
 678
 679         p = (u_char *) argv[i];
 680
 681         if (*p++ != '-') {
 682             ngx_log_stderr(0, "invalid option: \"%s\"", argv[i]);
 683             return NGX_ERROR;
 684         }
 685
 686         while (*p) {
 687
 688             switch (*p++) {
 689
 690             case '?':
 691             case 'h':
 692                 ngx_show_version = 1;
 693                 ngx_show_help = 1;
 694                 break;
 695
 696             case 'v':
 697                 ngx_show_version = 1;
 698                 break;
 699
 700             case 'V':
 701                 ngx_show_version = 1;
 702                 ngx_show_configure = 1;
 703                 break;
 704
 705             case 't':
 706                 ngx_test_config = 1;
 707                 break;
 708
 709             case 'q':
 710                 ngx_quiet_mode = 1;
 711                 break;
 712
 713             case 'p':
 714                 if (*p) {
 715                     ngx_prefix = p;
 716                     goto next;
 717                 }
 718
 719                 if (argv[++i]) {
 720                     ngx_prefix = (u_char *) argv[i];
 721                     goto next;
 722                 }
 723
 724                 ngx_log_stderr(0, "option \"-p\" requires directory name");
 725                 return NGX_ERROR;
 726
 727             case 'c':
 728                 if (*p) {
 729                     ngx_conf_file = p;
 730                     goto next;
 731                 }
 732
 733                 if (argv[++i]) {
 734                     ngx_conf_file = (u_char *) argv[i];
 735                     goto next;
 736                 }
 737
 738                 ngx_log_stderr(0, "option \"-c\" requires file name");
 739                 return NGX_ERROR;
 740
 741             case 'g':
 742                 if (*p) {
 743                     ngx_conf_params = p;
 744                     goto next;
 745                 }
 746
 747                 if (argv[++i]) {
 748                     ngx_conf_params = (u_char *) argv[i];
 749                     goto next;
 750                 }
 751
 752                 ngx_log_stderr(0, "option \"-g\" requires parameter");
 753                 return NGX_ERROR;
 754
 755             case 's':
 756                 if (*p) {
 757                     ngx_signal = (char *) p;
 758
 759                 } else if (argv[++i]) {
 760                     ngx_signal = argv[i];
 761
 762                 } else {
 763                     ngx_log_stderr(0, "option \"-s\" requires parameter");
 764                     return NGX_ERROR;
 765                 }
 766
 767                 if (ngx_strcmp(ngx_signal, "stop") == 0
 768                     || ngx_strcmp(ngx_signal, "quit") == 0
 769                     || ngx_strcmp(ngx_signal, "reopen") == 0
 770                     || ngx_strcmp(ngx_signal, "reload") == 0)
 771                 {
 772                     ngx_process = NGX_PROCESS_SIGNALLER;
 773                     goto next;
 774                 }
 775
 776                 ngx_log_stderr(0, "invalid option: \"-s %s\"", ngx_signal);
 777                 return NGX_ERROR;
 778
 779             default:
 780                 ngx_log_stderr(0, "invalid option: \"%c\"", *(p - 1));
 781                 return NGX_ERROR;
 782             }
 783         }
 784
 785     next:
 786
 787         continue;
 788     }
 789
 790     return NGX_OK;
 791 }
 792
 793
 794 static ngx_int_t
 795 ngx_save_argv(ngx_cycle_t *cycle, int argc, char *const *argv)
 796 {
 797 #if (NGX_FREEBSD)
 798
 799     ngx_os_argv = (char **) argv;
 800     ngx_argc = argc;
 801     ngx_argv = (char **) argv;
 802
 803 #else
 804     size_t     len;
 805     ngx_int_t  i;
 806
 807     ngx_os_argv = (char **) argv;
 808     ngx_argc = argc;
 809
 810     ngx_argv = ngx_alloc((argc + 1) * sizeof(char *), cycle-&gt;log);
 811     if (ngx_argv == NULL) {
 812         return NGX_ERROR;
 813     }
 814
 815     for (i = 0; i &lt; argc; i++) {
 816         len = ngx_strlen(argv[i]) + 1;
 817
 818         ngx_argv[i] = ngx_alloc(len, cycle-&gt;log);
 819         if (ngx_argv[i] == NULL) {
 820             return NGX_ERROR;
 821         }
 822
 823         (void) ngx_cpystrn((u_char *) ngx_argv[i], (u_char *) argv[i], len);
 824     }
 825
 826     ngx_argv[i] = NULL;
 827
 828 #endif
 829
 830     ngx_os_environ = environ;
 831
 832     return NGX_OK;
 833 }
 834
 835
 836 static ngx_int_t
 837 ngx_process_options(ngx_cycle_t *cycle)
 838 {
 839     u_char  *p;
 840     size_t   len;
 841
 842     if (ngx_prefix) {
 843         len = ngx_strlen(ngx_prefix);
 844         p = ngx_prefix;
 845
 846         if (len &amp;&amp; !ngx_path_separator(p[len - 1])) {
 847             p = ngx_pnalloc(cycle-&gt;pool, len + 1);
 848             if (p == NULL) {
 849                 return NGX_ERROR;
 850             }
 851
 852             ngx_memcpy(p, ngx_prefix, len);
 853             p[len++] = '/';
 854         }
 855
 856         cycle-&gt;conf_prefix.len = len;
 857         cycle-&gt;conf_prefix.data = p;
 858         cycle-&gt;prefix.len = len;
 859         cycle-&gt;prefix.data = p;
 860
 861     } else {
 862
 863 #ifndef NGX_PREFIX
 864
 865         p = ngx_pnalloc(cycle-&gt;pool, NGX_MAX_PATH);
 866         if (p == NULL) {
 867             return NGX_ERROR;
 868         }
 869
 870         if (ngx_getcwd(p, NGX_MAX_PATH) == 0) {
 871             ngx_log_stderr(ngx_errno, "[emerg]: " ngx_getcwd_n " failed");
 872             return NGX_ERROR;
 873         }
 874
 875         len = ngx_strlen(p);
 876
 877         p[len++] = '/';
 878
 879         cycle-&gt;conf_prefix.len = len;
 880         cycle-&gt;conf_prefix.data = p;
 881         cycle-&gt;prefix.len = len;
 882         cycle-&gt;prefix.data = p;
 883
 884 #else
 885
 886 #ifdef NGX_CONF_PREFIX
 887         ngx_str_set(&amp;cycle-&gt;conf_prefix, NGX_CONF_PREFIX);
 888 #else
 889         ngx_str_set(&amp;cycle-&gt;conf_prefix, NGX_PREFIX);
 890 #endif
 891         ngx_str_set(&amp;cycle-&gt;prefix, NGX_PREFIX);
 892
 893 #endif
 894     }
 895
 896     if (ngx_conf_file) {
 897         cycle-&gt;conf_file.len = ngx_strlen(ngx_conf_file);
 898         cycle-&gt;conf_file.data = ngx_conf_file;
 899
 900     } else {
 901         ngx_str_set(&amp;cycle-&gt;conf_file, NGX_CONF_PATH);
 902     }
 903
 904     if (ngx_conf_full_name(cycle, &amp;cycle-&gt;conf_file, 0) != NGX_OK) {
 905         return NGX_ERROR;
 906     }
 907
 908     for (p = cycle-&gt;conf_file.data + cycle-&gt;conf_file.len - 1;
 909          p &gt; cycle-&gt;conf_file.data;
 910          p--)
 911     {
 912         if (ngx_path_separator(*p)) {
 913             cycle-&gt;conf_prefix.len = p - ngx_cycle-&gt;conf_file.data + 1;
 914             cycle-&gt;conf_prefix.data = ngx_cycle-&gt;conf_file.data;
 915             break;
 916         }
 917     }
 918
 919     if (ngx_conf_params) {
 920         cycle-&gt;conf_param.len = ngx_strlen(ngx_conf_params);
 921         cycle-&gt;conf_param.data = ngx_conf_params;
 922     }
 923
 924     if (ngx_test_config) {
 925         cycle-&gt;log-&gt;log_level = NGX_LOG_INFO;
 926     }
 927
 928     return NGX_OK;
 929 }
 930
 931
 932 static void *
 933 ngx_core_module_create_conf(ngx_cycle_t *cycle)
 934 {
 935     ngx_core_conf_t  *ccf;
 936
 937     ccf = ngx_pcalloc(cycle-&gt;pool, sizeof(ngx_core_conf_t));
 938     if (ccf == NULL) {
 939         return NULL;
 940     }
 941
 942     /*
 943      * set by ngx_pcalloc()
 944      *
 945      *     ccf-&gt;pid = NULL;
 946      *     ccf-&gt;oldpid = NULL;
 947      *     ccf-&gt;priority = 0;
 948      *     ccf-&gt;cpu_affinity_n = 0;
 949      *     ccf-&gt;cpu_affinity = NULL;
 950      */
 951
 952     ccf-&gt;daemon = NGX_CONF_UNSET;
 953     ccf-&gt;master = NGX_CONF_UNSET;
 954     ccf-&gt;timer_resolution = NGX_CONF_UNSET_MSEC;
 955
 956     ccf-&gt;worker_processes = NGX_CONF_UNSET;
 957     ccf-&gt;debug_points = NGX_CONF_UNSET;
 958
 959     ccf-&gt;rlimit_nofile = NGX_CONF_UNSET;
 960     ccf-&gt;rlimit_core = NGX_CONF_UNSET;
 961     ccf-&gt;rlimit_sigpending = NGX_CONF_UNSET;
 962
 963     ccf-&gt;user = (ngx_uid_t) NGX_CONF_UNSET_UINT;
 964     ccf-&gt;group = (ngx_gid_t) NGX_CONF_UNSET_UINT;
 965
 966 #if (NGX_THREADS)
 967     ccf-&gt;worker_threads = NGX_CONF_UNSET;
 968     ccf-&gt;thread_stack_size = NGX_CONF_UNSET_SIZE;
 969 #endif
 970
 971     if (ngx_array_init(&amp;ccf-&gt;env, cycle-&gt;pool, 1, sizeof(ngx_str_t))
 972         != NGX_OK)
 973     {
 974         return NULL;
 975     }
 976
 977     return ccf;
 978 }
 979
 980
 981 static char *
 982 ngx_core_module_init_conf(ngx_cycle_t *cycle, void *conf)
 983 {
 984     ngx_core_conf_t  *ccf = conf;
 985
 986     ngx_conf_init_value(ccf-&gt;daemon, 1);
 987     ngx_conf_init_value(ccf-&gt;master, 1);
 988     ngx_conf_init_msec_value(ccf-&gt;timer_resolution, 0);
 989
 990     ngx_conf_init_value(ccf-&gt;worker_processes, 1);
 991     ngx_conf_init_value(ccf-&gt;debug_points, 0);
 992
 993 #if (NGX_HAVE_CPU_AFFINITY)
 994
 995     if (ccf-&gt;cpu_affinity_n
 996         &amp;&amp; ccf-&gt;cpu_affinity_n != 1
 997         &amp;&amp; ccf-&gt;cpu_affinity_n != (ngx_uint_t) ccf-&gt;worker_processes)
 998     {
 999         ngx_log_error(NGX_LOG_WARN, cycle-&gt;log, 0,
1000                       "the number of \"worker_processes\" is not equal to "
1001                       "the number of \"worker_cpu_affinity\" masks, "
1002                       "using last mask for remaining worker processes");
1003     }
1004
1005 #endif
1006
1007 #if (NGX_THREADS)
1008
1009     ngx_conf_init_value(ccf-&gt;worker_threads, 0);
1010     ngx_threads_n = ccf-&gt;worker_threads;
1011     ngx_conf_init_size_value(ccf-&gt;thread_stack_size, 2 * 1024 * 1024);
1012
1013 #endif
1014
1015
1016     if (ccf-&gt;pid.len == 0) {
1017         ngx_str_set(&amp;ccf-&gt;pid, NGX_PID_PATH);
1018     }
1019
1020     if (ngx_conf_full_name(cycle, &amp;ccf-&gt;pid, 0) != NGX_OK) {
1021         return NGX_CONF_ERROR;
1022     }
1023
1024     ccf-&gt;oldpid.len = ccf-&gt;pid.len + sizeof(NGX_OLDPID_EXT);
1025
1026     ccf-&gt;oldpid.data = ngx_pnalloc(cycle-&gt;pool, ccf-&gt;oldpid.len);
1027     if (ccf-&gt;oldpid.data == NULL) {
1028         return NGX_CONF_ERROR;
1029     }
1030
1031     ngx_memcpy(ngx_cpymem(ccf-&gt;oldpid.data, ccf-&gt;pid.data, ccf-&gt;pid.len),
1032                NGX_OLDPID_EXT, sizeof(NGX_OLDPID_EXT));
1033
1034
1035 #if !(NGX_WIN32)
1036
1037     if (ccf-&gt;user == (uid_t) NGX_CONF_UNSET_UINT &amp;&amp; geteuid() == 0) {
1038         struct group   *grp;
1039         struct passwd  *pwd;
1040
1041         ngx_set_errno(0);
1042         pwd = getpwnam(NGX_USER);
1043         if (pwd == NULL) {
1044             ngx_log_error(NGX_LOG_EMERG, cycle-&gt;log, ngx_errno,
1045                           "getpwnam(\"" NGX_USER "\") failed");
1046             return NGX_CONF_ERROR;
1047         }
1048
1049         ccf-&gt;username = NGX_USER;
1050         ccf-&gt;user = pwd-&gt;pw_uid;
1051
1052         ngx_set_errno(0);
1053         grp = getgrnam(NGX_GROUP);
1054         if (grp == NULL) {
1055             ngx_log_error(NGX_LOG_EMERG, cycle-&gt;log, ngx_errno,
1056                           "getgrnam(\"" NGX_GROUP "\") failed");
1057             return NGX_CONF_ERROR;
1058         }
1059
1060         ccf-&gt;group = grp-&gt;gr_gid;
1061     }
1062
1063
1064     if (ccf-&gt;lock_file.len == 0) {
1065         ngx_str_set(&amp;ccf-&gt;lock_file, NGX_LOCK_PATH);
1066     }
1067
1068     if (ngx_conf_full_name(cycle, &amp;ccf-&gt;lock_file, 0) != NGX_OK) {
1069         return NGX_CONF_ERROR;
1070     }
1071
1072     {
1073     ngx_str_t  lock_file;
1074
1075     lock_file = cycle-&gt;old_cycle-&gt;lock_file;
1076
1077     if (lock_file.len) {
1078         lock_file.len--;
1079
1080         if (ccf-&gt;lock_file.len != lock_file.len
1081             || ngx_strncmp(ccf-&gt;lock_file.data, lock_file.data, lock_file.len)
1082                != 0)
1083         {
1084             ngx_log_error(NGX_LOG_EMERG, cycle-&gt;log, 0,
1085                           "\"lock_file\" could not be changed, ignored");
1086         }
1087
1088         cycle-&gt;lock_file.len = lock_file.len + 1;
1089         lock_file.len += sizeof(".accept");
1090
1091         cycle-&gt;lock_file.data = ngx_pstrdup(cycle-&gt;pool, &amp;lock_file);
1092         if (cycle-&gt;lock_file.data == NULL) {
1093             return NGX_CONF_ERROR;
1094         }
1095
1096     } else {
1097         cycle-&gt;lock_file.len = ccf-&gt;lock_file.len + 1;
1098         cycle-&gt;lock_file.data = ngx_pnalloc(cycle-&gt;pool,
1099                                       ccf-&gt;lock_file.len + sizeof(".accept"));
1100         if (cycle-&gt;lock_file.data == NULL) {
1101             return NGX_CONF_ERROR;
1102         }
1103
1104         ngx_memcpy(ngx_cpymem(cycle-&gt;lock_file.data, ccf-&gt;lock_file.data,
1105                               ccf-&gt;lock_file.len),
1106                    ".accept", sizeof(".accept"));
1107     }
1108     }
1109
1110 #endif
1111
1112     return NGX_CONF_OK;
1113 }
1114
1115
1116 static char *
1117 ngx_set_user(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
1118 {
1119 #if (NGX_WIN32)
1120
1121     ngx_conf_log_error(NGX_LOG_WARN, cf, 0,
1122                        "\"user\" is not supported, ignored");
1123
1124     return NGX_CONF_OK;
1125
1126 #else
1127
1128     ngx_core_conf_t  *ccf = conf;
1129
1130     char             *group;
1131     struct passwd    *pwd;
1132     struct group     *grp;
1133     ngx_str_t        *value;
1134
1135     if (ccf-&gt;user != (uid_t) NGX_CONF_UNSET_UINT) {
1136         return "is duplicate";
1137     }
1138
1139     if (geteuid() != 0) {
1140         ngx_conf_log_error(NGX_LOG_WARN, cf, 0,
1141                            "the \"user\" directive makes sense only "
1142                            "if the master process runs "
1143                            "with super-user privileges, ignored");
1144         return NGX_CONF_OK;
1145     }
1146
1147     value = (ngx_str_t *) cf-&gt;args-&gt;elts;
1148
1149     ccf-&gt;username = (char *) value[1].data;
1150
1151     ngx_set_errno(0);
1152     pwd = getpwnam((const char *) value[1].data);
1153     if (pwd == NULL) {
1154         ngx_conf_log_error(NGX_LOG_EMERG, cf, ngx_errno,
1155                            "getpwnam(\"%s\") failed", value[1].data);
1156         return NGX_CONF_ERROR;
1157     }
1158
1159     ccf-&gt;user = pwd-&gt;pw_uid;
1160
1161     group = (char *) ((cf-&gt;args-&gt;nelts == 2) ? value[1].data : value[2].data);
1162
1163     ngx_set_errno(0);
1164     grp = getgrnam(group);
1165     if (grp == NULL) {
1166         ngx_conf_log_error(NGX_LOG_EMERG, cf, ngx_errno,
1167                            "getgrnam(\"%s\") failed", group);
1168         return NGX_CONF_ERROR;
1169     }
1170
1171     ccf-&gt;group = grp-&gt;gr_gid;
1172
1173     return NGX_CONF_OK;
1174
1175 #endif
1176 }
1177
1178
1179 static char *
1180 ngx_set_env(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
1181 {
1182     ngx_core_conf_t  *ccf = conf;
1183
1184     ngx_str_t   *value, *var;
1185     ngx_uint_t   i;
1186
1187     var = ngx_array_push(&amp;ccf-&gt;env);
1188     if (var == NULL) {
1189         return NGX_CONF_ERROR;
1190     }
1191
1192     value = cf-&gt;args-&gt;elts;
1193     *var = value[1];
1194
1195     for (i = 0; i &lt; value[1].len; i++) {
1196
1197         if (value[1].data[i] == '=') {
1198
1199             var-&gt;len = i;
1200
1201             return NGX_CONF_OK;
1202         }
1203     }
1204
1205     return NGX_CONF_OK;
1206 }
1207
1208
1209 static char *
1210 ngx_set_priority(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
1211 {
1212     ngx_core_conf_t  *ccf = conf;
1213
1214     ngx_str_t        *value;
1215     ngx_uint_t        n, minus;
1216
1217     if (ccf-&gt;priority != 0) {
1218         return "is duplicate";
1219     }
1220
1221     value = cf-&gt;args-&gt;elts;
1222
1223     if (value[1].data[0] == '-') {
1224         n = 1;
1225         minus = 1;
1226
1227     } else if (value[1].data[0] == '+') {
1228         n = 1;
1229         minus = 0;
1230
1231     } else {
1232         n = 0;
1233         minus = 0;
1234     }
1235
1236     ccf-&gt;priority = ngx_atoi(&amp;value[1].data[n], value[1].len - n);
1237     if (ccf-&gt;priority == NGX_ERROR) {
1238         return "invalid number";
1239     }
1240
1241     if (minus) {
1242         ccf-&gt;priority = -ccf-&gt;priority;
1243     }
1244
1245     return NGX_CONF_OK;
1246 }
1247
1248
1249 static char *
1250 ngx_set_cpu_affinity(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
1251 {
1252 #if (NGX_HAVE_CPU_AFFINITY)
1253     ngx_core_conf_t  *ccf = conf;
1254
1255     u_char            ch;
1256     uint64_t         *mask;
1257     ngx_str_t        *value;
1258     ngx_uint_t        i, n;
1259
1260     if (ccf-&gt;cpu_affinity) {
1261         return "is duplicate";
1262     }
1263
1264     mask = ngx_palloc(cf-&gt;pool, (cf-&gt;args-&gt;nelts - 1) * sizeof(uint64_t));
1265     if (mask == NULL) {
1266         return NGX_CONF_ERROR;
1267     }
1268
1269     ccf-&gt;cpu_affinity_n = cf-&gt;args-&gt;nelts - 1;
1270     ccf-&gt;cpu_affinity = mask;
1271
1272     value = cf-&gt;args-&gt;elts;
1273
1274     for (n = 1; n &lt; cf-&gt;args-&gt;nelts; n++) {
1275
1276         if (value[n].len &gt; 64) {
1277             ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
1278                          "\"worker_cpu_affinity\" supports up to 64 CPUs only");
1279             return NGX_CONF_ERROR;
1280         }
1281
1282         mask[n - 1] = 0;
1283
1284         for (i = 0; i &lt; value[n].len; i++) {
1285
1286             ch = value[n].data[i];
1287
1288             if (ch == ' ') {
1289                 continue;
1290             }
1291
1292             mask[n - 1] &lt;&lt;= 1;
1293
1294             if (ch == '0') {
1295                 continue;
1296             }
1297
1298             if (ch == '1') {
1299                 mask[n - 1] |= 1;
1300                 continue;
1301             }
1302
1303             ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
1304                           "invalid character \"%c\" in \"worker_cpu_affinity\"",
1305                           ch);
1306             return NGX_CONF_ERROR;
1307         }
1308     }
1309
1310 #else
1311
1312     ngx_conf_log_error(NGX_LOG_WARN, cf, 0,
1313                        "\"worker_cpu_affinity\" is not supported "
1314                        "on this platform, ignored");
1315 #endif
1316
1317     return NGX_CONF_OK;
1318 }
1319
1320
1321 uint64_t
1322 ngx_get_cpu_affinity(ngx_uint_t n)
1323 {
1324     ngx_core_conf_t  *ccf;
1325
1326     ccf = (ngx_core_conf_t *) ngx_get_conf(ngx_cycle-&gt;conf_ctx,
1327                                            ngx_core_module);
1328
1329     if (ccf-&gt;cpu_affinity == NULL) {
1330         return 0;
1331     }
1332
1333     if (ccf-&gt;cpu_affinity_n &gt; n) {
1334         return ccf-&gt;cpu_affinity[n];
1335     }
1336
1337     return ccf-&gt;cpu_affinity[ccf-&gt;cpu_affinity_n - 1];
1338 }
1339
1340
1341 static char *
1342 ngx_set_worker_processes(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
1343 {
1344     ngx_str_t        *value;
1345     ngx_core_conf_t  *ccf;
1346
1347     ccf = (ngx_core_conf_t *) conf;
1348
1349     if (ccf-&gt;worker_processes != NGX_CONF_UNSET) {
1350         return "is duplicate";
1351     }
1352
1353     value = (ngx_str_t *) cf-&gt;args-&gt;elts;
1354
1355     if (ngx_strcmp(value[1].data, "auto") == 0) {
1356         ccf-&gt;worker_processes = ngx_ncpu;
1357         return NGX_CONF_OK;
1358     }
1359
1360     ccf-&gt;worker_processes = ngx_atoi(value[1].data, value[1].len);
1361
1362     if (ccf-&gt;worker_processes == NGX_ERROR) {
1363         return "invalid value";
1364     }
1365
1366     return NGX_CONF_OK;
1367 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>　　Nginx的启动包括了很多的初始化和处理函数。这些函数相对来说，有一部分非常复杂，暂且从简单开始，从整体上对Ngixnd的启动有一个了解，方便日后的分析与学习。</p>
<p>　　主要函数：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>//完成socket的继承
static ngx_int_t ngx_add_inherited_sockets(ngx_cycle_t *cycle);//对参数选项进行处理
static ngx_int_t ngx_get_options(int argc, char *const *argv);//初始化ngx_cycle内的部分内容
static ngx_int_t ngx_process_options(ngx_cycle_t *cycle);//命令行参数保存到ngx_os_argv、ngx_argc以及ngx_argv全局的变量中
static ngx_int_t ngx_save_argv(ngx_cycle_t *cycle, int argc, char *const *argv);
//创建模块的配置信息
static void *ngx_core_module_create_conf(ngx_cycle_t *cycle);//初始化配置信息
static char *ngx_core_module_init_conf(ngx_cycle_t *cycle, void *conf);
static char *ngx_set_user(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);
static char *ngx_set_env(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);//设置优先级
static char *ngx_set_priority(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);//设置CPU亲和性
static char *ngx_set_cpu_affinity(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);//设置worker进程
static char *ngx_set_worker_processes(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h2>Nginx启动的主要流程</h2>
<p> 　　下图为Nginx的启动时函数的调用过程，其中大部分都是为了Nginx启动的初始化部分。从错误处理、参数设置、时间设置等方面进行初始化，并注册了我们需要的模块，最后根据信号选择单任务模式还是master-worker模式。</p>
<p>　　流程图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQ1Mjg5OS8yMDEzMDcvMDIyMDU0MjMtNjRhY2Q0M2I4Njk2NDk0ODlkNWI1NzhkNGM4NmM5ZjkucG5n.jpg"></p>
<h3>初始化</h3>
<p>　　主函数在开始对系统错误、参数、时间、系统变量、日志等进行了初始化。</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>//初始化系统中错误编号对应的含义
ngx_strerror_init();
//对参数选项进行处理
ngx_get_options(argc, argv);
//时间初始化
ngx_time_init();
//重置pcre内存管理的接口
ngx_regex_init();
//日志初始化
ngx_log_init(ngx_prefix);//创建内存池
ngx_create_pool(1024, log);//保存变量
ngx_save_argv();//初始化ngx_cycle的prefix, conf_prefix, conf_file, conf_param
ngx_process_options();//初始化系统相关变量，如内存页面大小ngx_pagesize,ngx_cacheline_size,最大连接数ngx_max_sockets等
ngx_os_init();//初始化CRC表(后续的CRC校验通过查表进行，效率高)
ngx_crc32_table_init();</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h3>主要工作</h3>
<p>　　初始化完成后，需要先调用ngx_add_inherited_sockets函数继承socket，并储存在Listening数组中，在运行时候进行监听。之后就可以调用ngx_init_cycle来初始化ngx_cycle结构体，这个结构体用来存储所有的连接，具体如下：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>struct ngx_cycle_s {
    void                  ****conf_ctx;//配置上下文数组(含所有模块)
    ngx_pool_t               *pool;//内存池

    ngx_log_t                *log;//日志
    ngx_log_t                 new_log;

    ngx_connection_t        **files;//连接文件
    ngx_connection_t         *free_connections;//空闲连接
    ngx_uint_t                free_connection_n;//空闲连接数

    ngx_queue_t               reusable_connections_queue;////再利用连接队列  

    ngx_array_t               listening;//监听数组
    ngx_array_t               paths;//路径数组
    ngx_list_t                open_files;//打开文件链表
    ngx_list_t                shared_memory;//共享内存链表

    ngx_uint_t                connection_n;//连接个数  
    ngx_uint_t                files_n;//打开文件个数 

    ngx_connection_t         *connections;
    ngx_event_t              *read_events;//读事件
    ngx_event_t              *write_events;//写事件

    ngx_cycle_t              *old_cycle;

    ngx_str_t                 conf_file;//配置文件  
    ngx_str_t                 conf_param;//配置参数
    ngx_str_t                 conf_prefix;//配置前缀
    ngx_str_t                 prefix;//前缀
    ngx_str_t                 lock_file;//锁文件
    ngx_str_t                 hostname;</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>　　调用ngx_init_signals来注册信号。</p>
<pre>//信号种类
#define NGX_PROCESS_SINGLE 0
#define NGX_PROCESS_MASTER 1
#define NGX_PROCESS_SIGNALLER 2
#define NGX_PROCESS_WORKER 3
#define NGX_PROCESS_HELPER 4</pre>
<p>　　在进入处理之前，还要调用ngx_create_pidfile来记录进程id。最后，根据接收到的信号，来判断调用ngx_single_process_cycle还是ngx_master_process_cycle（master-worker模式）。</p>
<pre>if (ngx_process == NGX_PROCESS_SINGLE) {
        ngx_single_process_cycle(cycle);
} else {
        ngx_master_process_cycle(cycle);
}</pre>
<p> </p>
<p>　　其中，守护进程函数为ngx_daemon，位于src/os/unix/Ngx_daemon.c</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>//daemon
ngx_int_t
ngx_daemon(ngx_log_t *log)
{
    int  fd;
    switch (fork()) {
    case -1:
        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno, "fork() failed");
        return NGX_ERROR;
    case 0:
        breakdefault:
        exit(0);
    }

    ngx_pid = ngx_getpid();//取得进程识别码

    if (setsid() == -1) {  //子进程将重新获得一个新的会话(session)id
        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno, "setsid() failed");
        return NGX_ERROR;
    }

    umask(0);

    fd = open("/dev/null", O_RDWR);
    if (fd == -1) {
        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
                      "open(\"/dev/null\") failed");
        return NGX_ERROR;
    }

    if (dup2(fd, STDIN_FILENO) == -1) {
        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno, "dup2(STDIN) failed");
        return NGX_ERROR;
    }

    if (dup2(fd, STDOUT_FILENO) == -1) {
        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno, "dup2(STDOUT) failed");
        return NGX_ERROR;
    }

#if 0
    if (dup2(fd, STDERR_FILENO) == -1) {
        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno, "dup2(STDERR) failed");
        return NGX_ERROR;
    }
#endif

    if (fd &gt; STDERR_FILENO) {
        if (close(fd) == -1) {
            ngx_log_error(NGX_LOG_EMERG, log, ngx_errno, "close() failed");
            return NGX_ERROR;
        }
    }
    return NGX_OK;
}</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<h2> 参考</h2>
<p><a href="http://blog.xiuwz.com/2011/11/29/nginx-pcre-conflict/" rel="external nofollow noreferrer">http://blog.xiuwz.com/2011/11/29/nginx-pcre-conflict/</a></p>
<p><a href="http://blog.csdn.net/liuhongxiangm/article/details/8107613" rel="external nofollow noreferrer">http://blog.csdn.net/liuhongxiangm/article/details/8107613</a></p>
<p><a href="http://www.4os.org/index.php/2010/11/25/nginx%E5%90%AF%E5%8A%A8%E5%88%9D%E5%A7%8B%E5%8C%96%E8%BF%87%E7%A8%8B%E8%BD%AC%E8%BD%BD/" rel="external nofollow noreferrer">http://www.4os.org/index.php/2010/11/25/nginx%E5%90%AF%E5%8A%A8%E5%88%9D%E5%A7%8B%E5%8C%96%E8%BF%87%E7%A8%8B%E8%BD%AC%E8%BD%BD/</a></p>
<p><a href="http://blog.csdn.net/livelylittlefish/article/details/7243718" rel="external nofollow noreferrer">http://blog.csdn.net/livelylittlefish/article/details/7243718</a></p>
<blockquote><p><a href="http://creativecommons.org/licenses/by-nc-sa/3.0/cn/" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5jcmVhdGl2ZWNvbW1vbnMub3JnL2wvYnktbmMtc2EvMy4wL2NuLzg4eDMxLnBuZw==.jpg"></a><br />
本文 由 <a href="http://www.cnblogs.com/coder2012/p/3142632.html" rel="external nofollow noreferrer">cococo点点</a> 创作，采用 <a href="http://creativecommons.org/licenses/by-nc-sa/3.0/cn/" rel="external nofollow noreferrer">知识共享 署名-非商业性使用-相同方式共享 3.0 中国大陆 许可协议</a>进行许可。欢迎转载，请注明出处：<br />
转载自：<a href="http://www.cnblogs.com/coder2012" rel="external nofollow noreferrer">cococo点点</a> <a href="http://www.cnblogs.com/coder2012" rel="external nofollow noreferrer">http://www.cnblogs.com/coder2012</a></p></blockquote>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-30 04:42:05</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8%e5%bc%80%e5%8f%91/" title="服务器开发">服务器开发</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Nginx学习笔记（六） 源码分析&amp;启动过程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV0jglM.html" rel="bookmark">TensorFlow学习笔记之四&mdash;&mdash;源码分析之基本操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				例子源码地址: https://github.com/aymericdamien/TensorFlow-Examples/blob/master/examples/1%20-%20Introduction/basic_operations.py 根据网上的入门例子,一点点的熟悉代码和TensorFlow.对这个基本的例子,做一个注释,备忘之余分享给同样入门的初学者. import tensorflow as tf a = tf.constant(2) b = tf.constant(3) #把a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3r6Ykz.html" rel="bookmark">《深入剖析Nginx》&mdash;&mdash;1&period;4 源码分析工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 源码分析工具 对于Windows平台,首选Source Insight1源码阅读工具.该工具功能强大,根据其官方网站的介绍,Source Insight是一款面向项目开发的程序编辑器和代码浏览器,它拥有内置的对C/C++.C#和Java等程序的分析功能.Source Insight能自动分析和动态维护源码工程的符号数据库,并在用户查看代码时显示有用的对应上下文信息. 如果是在Linux平台下,则可以利用Vi2.Taglist3.Cscope4以及Ctag5这几个工具来组合成阅读Nginx			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQd4kp.html" rel="bookmark">TOMCAT源码分析&mdash;&mdash;启动服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 熟悉Tomcat的工程师们,肯定都知道Tomcat是如何启动与停止的.对于startup.sh.startup.bat.shutdown.sh.shutdown.bat等脚本或者批处理命令,大家一定知道改如何使用它,但是它们究竟是如何实现的,尤其是shutdown.sh脚本(或者shutdown.bat)究竟是如何和Tomcat进程通信的呢?本文将通过对Tomcat7.0的源码阅读,深入剖析这一过程. 由于在生产环境中,Tomcat一般部署在Linux系统下,所以本文将以startup.s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgR06Ab.html" rel="bookmark">Nginx学习笔记六Nginx的模块开发</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Nginx配置文件主要组成:main(全局配置)这部分的指令将影响其他所有部分.server(虚拟主机配置)这部分指令主要用于指定虚拟主机域名,IP和端口.upstream(主要为反向代理,负载均衡相关配置)这部分指令用于设置反向代理及后端服务 器的负载均衡.location(目录匹配配置)这部分指令用于匹配网页位置(例如,根目录&quot;/&quot;,&quot;/images&quot;,等 等). location部分会继承server部分的指令,而server部分会继承main部分的指令.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1NjRxp.html" rel="bookmark">Yaf框架学习笔记之源码笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  从了解PHP不久就想着用扩展的方式来实现PHP的程序框架,后来了解鸟哥已经实现了yaf简单的C实现PHP的MVC框架,故将其源代码研究了好几遍.yaf的优势是简单,高效,高性能,框架长驻内存,程序配置内存化,其实主要是运行速度比大部分PHP的框架都快. 1.在内核扩展中加载PHP用户空间类文件 文件:yaf_loader.c 函数:int yaf_loader_import( char path, int len int use_path TSRMLS_DC) 行号:333 2.自动加载器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBgk14M.html" rel="bookmark">MySQL &CenterDot; 源码分析 &CenterDot; SHUTDOWN过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ORACLE 中的SHUTDOWN MySQL SHUTDOWN LEVEL 暂时只有一种,源码中留了 LEVEL 的坑还没填 在此借用 Oracle 的 SHUTDOWN LEVEL 分析 Oracle SHUTDOWN LEVEL 共有四种:ABORT.IMMEDIATE.NORMAL.TRANSACTIONAL ABORT 立即结束所有SQL 回滚未提交事务 断开所有用户连接 下次启动实例时,需要recovery IMMEDIATE 允许正在运行的SQL执行完毕 回滚未提交事务 断开所有用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pker4yb.html" rel="bookmark">TOMCAT源码分析&mdash;&mdash;停止服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在&lt;TOMCAT源码分析--启动服务&gt;一文中我介绍了Tomcat服务的启动过程分析,本文讲解Tomcat服务是如何停止的. 停止过程分析 我们停止Tomcat的命令如下: sh shutdown.sh 所以,将从shell脚本shutdown.sh开始分析Tomcat的停止过程.shutdown.sh的脚本代码见代码清单10. 代码清单10 os400=false case &quot;`uname`&quot; in OS400*) os400=true;; esac # resolv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP2Ljmb.html" rel="bookmark">springboot源码分析6-springboot之PropertySource类初探</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要:本小节重点梳理一下PropertySource类的相关结构以及职责,本文的学习前提是学习了springboot源码分析5-springboot之命令行参数以及原理一文. 在springboot源码分析5-springboot之命令行参数以及原理一文中,我们看到了实例化Source类的时候,会去先实例化其父类SimpleCommandLinePropertySource.SimpleCommandLinePropertySource类的构造函数中直接解析了命令行参数以及值,然后返回封装好的C			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEKd86p.html" rel="bookmark">Cocos2d-x学习笔记之Hello World源码分析&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先我们来说一下游戏的原理,游戏类似于一场电影,早期的电影不就是靠一张张的图片放出来的吗?把场景人物什么的画在一幅幅图片上,然后从第一张图片开始播放就可以了.游戏更是如此,其实我们玩的游戏看到的画面都是美工做出来的,我们程序员要做的事情是组织这些图片,比如先弄个背景图片,然后在某一个坐标上放置一个人物的图片,我们写好程序,控制这个图片的移动路径,等机器运行的时候每秒都要刷新画面,我们就看到人物动了起来.而刷新页面的快慢就是我们所说的帧率,这个在程序中我们可以控制.整体的意思就是游戏不过是一些图片			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMr3oxp.html" rel="bookmark" class="title">Linux中修改&sol;etc&sol;profile或者&dollar;HOME&sol;&period;profile文件后如何立即生效&quest;</a>
					<div>
						Linux中修改/etc/profile或者$HOME/.profile文件后如何立即生效? 当我们在管理/etc/profile文件时,进行了一些定制的修改,哪么如何才能立即生效呢? [root@l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy0r8b.html" rel="bookmark" class="title">&amp;amp&semi;&num;106avascript 小技巧&lpar;第七集&rpar;</a>
					<div>
						技巧 第七集 如何去产生乱数 接下来我们要为你介绍一个可以产生乱数的函数,也是以 JavaScript 所写的这个函数只是利用了一点小技巧而已.而这种技巧在大部分的编译器(compiler)中,大都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKVxEM.html" rel="bookmark" class="title">布线问题之短链路问题</a>
					<div>
						当在布线系统上执行测试时,实际上是使用一系列测试参数来测试系统.这些参数决定着测试的系统能否满足相应类别的性能要求,这种要求即TIA定义的标准规范,包括PS ACR.PSNEXT.PSFEXT.衰减等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62QmAM.html" rel="bookmark" class="title">C&num;多态性的概念及其应用</a>
					<div>
						多态是面向对象编程中三大机制之一,其原理建立在&quot;从父类继承而来的 子类可以转换为其父类&quot;这个规则之上,换句话说,能用父类的地方,就能用 该类的子类.当从父类派生了很多子类时,由于每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnZNlz.html" rel="bookmark" class="title">Visual Studio DSL 入门 11---为状态机设计器添加规则</a>
					<div>
						上一节我们在设计器的显示方面进行了完善,在这一节,我们将深入状态机设计器的一些逻辑细节,给我 们的设计器添加逻辑规则.为生成代码做好准备. 在开始之前,我们先看一下Transition的几个属性之间的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NdOmz.html" rel="bookmark" class="title">PS软件绘制蜡烛教程</a>
					<div>
						最终效果! 1.开始了,先描外形,用渐变填充-- 如&lt;图1&gt; &lt;图1&gt; 2.大致勾出颜色较深的部位 如&lt;图2&gt; &lt;图2&gt;					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjLn3p.html" rel="bookmark" class="title">asp查询记录</a>
					<div>
						  asp查询记录: 学习目的:学会数据库的基本操作--查询记录 在第四天中我们用到下面这样一个程序: 我们查询的是所有的记录,但是我们要修改.删除记录的时候不可能是所有记录,所有我们要学习检索合适的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jBD9b.html" rel="bookmark" class="title">Win7系统笔记本唤醒休眠模式后无线无法自动连接怎么办</a>
					<div>
						  Win7系统笔记本唤醒休眠模式后无线无法自动连接怎么办           故障原因: 出现这样的情况多半是在笔记本win7系统进入休眠或睡眠关闭了无线适配器的,这是由于电源选项设置为节能模式模式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PqB6M.html" rel="bookmark" class="title">PhotoShop调出质感黄褐色抽烟女孩效果教程</a>
					<div>
						教程教我们用PhotoShop调出质感黄褐色抽烟女孩效果.这只是调色思路,大家可以不要死套这数据,相信能有更多的好效果出现,比竟调色是一种思路的过程, 而不是数值的过程,希望大家能从创选的过程中领略到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXXxjp.html" rel="bookmark" class="title">Axure RP主界面介绍</a>
					<div>
						下图是Axure RP 环境与介面中各区块的简单描述. 放大图 主选单/工具列: 在主选单与工具列中,可以执行常用的动作指令,例如:开启与储存档案.输出Prototype或Spec文件. Sitema ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e0oOb.html" rel="bookmark" class="title">提高网页加载速度的初步简单技巧方式</a>
					<div>
						网页的加载速度是评估网站质量一个重要指标.原因在于大多数用户能够容忍的网页加载时间只有几秒,如果超出了访客的忍受范围他们会毫不留情地关掉你的网 页,所以网页载入速度会极大地影响网站的流量和访问.以下总 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0W6Gjb.html" rel="bookmark" class="title">怎样把百度网盘中的文件转移到360网盘？</a>
					<div>
						  第一步: 浏览器打开云盘--选中要搬运的单个文件(貌似多个文件会直接调用度盘客户端)--右键--下载--普通下载. 第二步: 点击普通下载后有两种情况:1.调用迅雷下载 2.浏览器直接下载 1.调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmGdWz.html" rel="bookmark" class="title">win7电脑如何设置以单独进程打开文件夹</a>
					<div>
						  在此之前,我们先来解释一下,什么叫做以单独进程打开文件夹,撇开这种专业术语,咱们用比较通俗的话来解释,其实就是咱们没打开一个文件夹,都会以新窗口的形式出来,而不会覆盖在原有的窗口中,虽然说很多人觉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN19Rob.html" rel="bookmark" class="title">Frontpage xp中巧用Ctrl键</a>
					<div>
						  说起Ctrl键,或许你马上就想到Ctrl+C.Ctrl+V等快捷方式,你也一定尝到了用快捷链的甜头儿,今天钟钟向大家介绍两个Ctrl键在Frontpage2000/xp(意为Frontpage20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWJrlp.html" rel="bookmark" class="title">android这段代码为什么无限启动相机&quest;应该怎么改&quest;</a>
					<div>
						问题描述 android这段代码为什么无限启动相机?应该怎么改? package nzy.ssp; import java.io.File; import nzy.ssp.net.AuthSina.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRaY6z.html" rel="bookmark" class="title">为什么一些机器学习模型需要对数据进行归一化？</a>
					<div>
						    机器学习模型被互联网行业广泛应用,如排序(参见:排序学习实践).推荐.反作弊.定位(参见:基于朴素贝叶斯的定位算法)等.一般做机器学习应用的时候大部分时间是花费在特征处理上,其中很关键的一步就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd8dEb.html" rel="bookmark" class="title">微软首席战略官称移动落后苹果怪黑客</a>
					<div>
						本文讲的是 :  微软首席战略官称移动落后苹果怪黑客  ,  在iPad销售记录过亿的情况下,微软的Surface平板似乎需要占据更多的市场地盘.目前,微软一名高管接受采访时指出,微软的落后并不全是公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKqe0z.html" rel="bookmark" class="title">深入理解Ubuntu Xwindow出色的图形系统</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   很多人在用 Xwindow,但是他们是在用一些包装掩盖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z409E9z.html" rel="bookmark" class="title">浏览器-Dreamweaver打开index&period;html变成了xxx&period;htm</a>
					<div>
						问题描述 Dreamweaver打开index.html变成了xxx.htm 这是什么鬼啊,而且浏览器一直加载不了新修改的样式. 解决方案 f12看下源码是否正确.另外看下css路径是否正确,尽量不要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAA5gvM.html" rel="bookmark" class="title">从JDK源码角度看Integer</a>
					<div>
						概况 Java的Integer类主要的作用就是对基本类型int进行封装,提供了一些处理int类型的方法,比如int到String类型的转换方法或String类型到int类型的转换方法,当然也包含与其他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjNQWM.html" rel="bookmark" class="title">电子商务的4个逻辑悖论</a>
					<div>
						最近,电子商务领域发生了不少事情,它们可能只是中国电子商务10年进程的小插曲,也可能正在为格局的变革埋下伏笔. 回顾中国互联网历史上先后出现的利益模型--门户广告.SP.增值服务.竞价排名.流氓软件. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw6QEM.html" rel="bookmark" class="title">《JavaScript启示录》&mdash;&mdash;1&period;16 typeof操作符</a>
					<div>
						1.16 typeof操作符 typeof操作符用于返回正在使用值的类型.但它返回的值并不一致,或者说,逻辑上不一致.下面的代码展示了使用typeof操作符所返回的值. &lt;!DOCTYPE ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqO36b.html" rel="bookmark" class="title">objective c-c&plus;&plus;结构的构造函数</a>
					<div>
						问题描述 c++结构的构造函数 有下面两个C++结构: struct Vertex3D{ GLfloat x; GLfloat y; GLfloat z; Vertex3D(GLfloat a, GL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWOyqM.html" rel="bookmark" class="title">云计算到底指什么？</a>
					<div>
						本文讲的是云计算到底指什么,[IT168 资讯]云计算的说法正在广为流行,Gartner高级分析师Ben Pring评价道:&quot;它正在成为一个大众化的词语.&quot;但是,问题是似乎每个人对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLdaVM.html" rel="bookmark" class="title">IOS 的弹性滚动解决方案&lowbar;IOS</a>
					<div>
						所谓弹性滚动就是指在翻动长页面手指离开时,由慢到块,由快到慢的过度. 安卓平台上的大多数浏览器都默认了该行为 ios当前还只对&lt;body&gt;下的 overflow 默认产生弹性滚动效果 前一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrwGvp.html" rel="bookmark" class="title">C&num;编程中HashSet和SortedSet的讲解及区别</a>
					<div>
						什么是C#中的集? 包含不重复元素的集合称为&quot;集(set)&quot;. .NET4包含两个集(HashSet&lt;T&gt;和SortedSet&lt;T&gt;),他们都实现ISet& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmq0Az.html" rel="bookmark" class="title">调试-阿里云服务提示有漏洞，请问关闭remote debug 模式？</a>
					<div>
						问题描述 阿里云服务提示有漏洞,请问关闭remote debug 模式? 请问各位有遇到过吗?是如何解决的?谢谢!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyLKWM.html" rel="bookmark" class="title">网络小胖：探索网站优化心得（一）</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 搞了优化这么久,一直想问自己搞优化 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqlrXp.html" rel="bookmark" class="title">《树莓派渗透测试实战》&mdash;&mdash;2&period;4　超频</a>
					<div>
						2.4 超频 树莓派可以通过超频提高性能.这么做的风险是有可能大大地缩减硬件的寿命.超频会导致树莓派消耗更多的电源,所以如果电源输出较弱,超频可能会有问题.在树莓派上超频可能会导致microSD卡损坏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrvk01M.html" rel="bookmark" class="title">让GoogleCode的SVN下的HTML文件在FireFox下正常显示&period;&lowbar;javascript技巧</a>
					<div>
						今天试了下发现GoogleCode提供的SVN中的HTML在Firefox中显示为HTML源文件 Google了一下,找到了答案: 如果正常显示需要在SVN提交文件时设置svn:mime-type 为 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.044 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
